% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/queue.R
\docType{class}
\name{Queue-class}
\alias{Queue}
\alias{Queue-class}
\title{A Queue reference class}
\description{
A Queue reference class
}
\section{Fields}{

\describe{
\item{\code{data}}{Initial data to populate the queue.}
}}
\section{Methods}{

\describe{
\item{\code{peek(pos = c(1), as.list = FALSE)}}{Returns (but does not remove) specified positions in queue (or NULL if any one of them is not available).
The as.list argument will cause a list to be returned even if only one element requested.}

\item{\code{poll()}}{Removes and returns head of queue (or NULL if queue is empty).}

\item{\code{pop(N = 1)}}{Removes and returns head of queue (or raises error if queue is empty). N is number of items to pop.}

\item{\code{push(item)}}{Inserts element at back of the queue.}

\item{\code{size()}}{Returns the number of items in the queue.}
}}
\examples{
queue <- Queue$new()
queue$push("one")
queue$push(2)
queue$push("three")
queue$size()
queue$pop()
queue$poll()
}

